# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AviatrixAwsTgwIntraDomainInspectionArgs', 'AviatrixAwsTgwIntraDomainInspection']

@pulumi.input_type
class AviatrixAwsTgwIntraDomainInspectionArgs:
    def __init__(__self__, *,
                 firewall_domain_name: pulumi.Input[str],
                 route_domain_name: pulumi.Input[str],
                 tgw_name: pulumi.Input[str]):
        """
        The set of arguments for constructing a AviatrixAwsTgwIntraDomainInspection resource.
        :param pulumi.Input[str] firewall_domain_name: Firewall domain name.
        :param pulumi.Input[str] route_domain_name: Route domain name.
        :param pulumi.Input[str] tgw_name: AWS TGW name.
        """
        pulumi.set(__self__, "firewall_domain_name", firewall_domain_name)
        pulumi.set(__self__, "route_domain_name", route_domain_name)
        pulumi.set(__self__, "tgw_name", tgw_name)

    @property
    @pulumi.getter(name="firewallDomainName")
    def firewall_domain_name(self) -> pulumi.Input[str]:
        """
        Firewall domain name.
        """
        return pulumi.get(self, "firewall_domain_name")

    @firewall_domain_name.setter
    def firewall_domain_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "firewall_domain_name", value)

    @property
    @pulumi.getter(name="routeDomainName")
    def route_domain_name(self) -> pulumi.Input[str]:
        """
        Route domain name.
        """
        return pulumi.get(self, "route_domain_name")

    @route_domain_name.setter
    def route_domain_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "route_domain_name", value)

    @property
    @pulumi.getter(name="tgwName")
    def tgw_name(self) -> pulumi.Input[str]:
        """
        AWS TGW name.
        """
        return pulumi.get(self, "tgw_name")

    @tgw_name.setter
    def tgw_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "tgw_name", value)


@pulumi.input_type
class _AviatrixAwsTgwIntraDomainInspectionState:
    def __init__(__self__, *,
                 firewall_domain_name: Optional[pulumi.Input[str]] = None,
                 route_domain_name: Optional[pulumi.Input[str]] = None,
                 tgw_name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AviatrixAwsTgwIntraDomainInspection resources.
        :param pulumi.Input[str] firewall_domain_name: Firewall domain name.
        :param pulumi.Input[str] route_domain_name: Route domain name.
        :param pulumi.Input[str] tgw_name: AWS TGW name.
        """
        if firewall_domain_name is not None:
            pulumi.set(__self__, "firewall_domain_name", firewall_domain_name)
        if route_domain_name is not None:
            pulumi.set(__self__, "route_domain_name", route_domain_name)
        if tgw_name is not None:
            pulumi.set(__self__, "tgw_name", tgw_name)

    @property
    @pulumi.getter(name="firewallDomainName")
    def firewall_domain_name(self) -> Optional[pulumi.Input[str]]:
        """
        Firewall domain name.
        """
        return pulumi.get(self, "firewall_domain_name")

    @firewall_domain_name.setter
    def firewall_domain_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "firewall_domain_name", value)

    @property
    @pulumi.getter(name="routeDomainName")
    def route_domain_name(self) -> Optional[pulumi.Input[str]]:
        """
        Route domain name.
        """
        return pulumi.get(self, "route_domain_name")

    @route_domain_name.setter
    def route_domain_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "route_domain_name", value)

    @property
    @pulumi.getter(name="tgwName")
    def tgw_name(self) -> Optional[pulumi.Input[str]]:
        """
        AWS TGW name.
        """
        return pulumi.get(self, "tgw_name")

    @tgw_name.setter
    def tgw_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tgw_name", value)


class AviatrixAwsTgwIntraDomainInspection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 firewall_domain_name: Optional[pulumi.Input[str]] = None,
                 route_domain_name: Optional[pulumi.Input[str]] = None,
                 tgw_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a AviatrixAwsTgwIntraDomainInspection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] firewall_domain_name: Firewall domain name.
        :param pulumi.Input[str] route_domain_name: Route domain name.
        :param pulumi.Input[str] tgw_name: AWS TGW name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AviatrixAwsTgwIntraDomainInspectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AviatrixAwsTgwIntraDomainInspection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AviatrixAwsTgwIntraDomainInspectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AviatrixAwsTgwIntraDomainInspectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 firewall_domain_name: Optional[pulumi.Input[str]] = None,
                 route_domain_name: Optional[pulumi.Input[str]] = None,
                 tgw_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AviatrixAwsTgwIntraDomainInspectionArgs.__new__(AviatrixAwsTgwIntraDomainInspectionArgs)

            if firewall_domain_name is None and not opts.urn:
                raise TypeError("Missing required property 'firewall_domain_name'")
            __props__.__dict__["firewall_domain_name"] = firewall_domain_name
            if route_domain_name is None and not opts.urn:
                raise TypeError("Missing required property 'route_domain_name'")
            __props__.__dict__["route_domain_name"] = route_domain_name
            if tgw_name is None and not opts.urn:
                raise TypeError("Missing required property 'tgw_name'")
            __props__.__dict__["tgw_name"] = tgw_name
        super(AviatrixAwsTgwIntraDomainInspection, __self__).__init__(
            'aviatrix:index/aviatrixAwsTgwIntraDomainInspection:AviatrixAwsTgwIntraDomainInspection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            firewall_domain_name: Optional[pulumi.Input[str]] = None,
            route_domain_name: Optional[pulumi.Input[str]] = None,
            tgw_name: Optional[pulumi.Input[str]] = None) -> 'AviatrixAwsTgwIntraDomainInspection':
        """
        Get an existing AviatrixAwsTgwIntraDomainInspection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] firewall_domain_name: Firewall domain name.
        :param pulumi.Input[str] route_domain_name: Route domain name.
        :param pulumi.Input[str] tgw_name: AWS TGW name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AviatrixAwsTgwIntraDomainInspectionState.__new__(_AviatrixAwsTgwIntraDomainInspectionState)

        __props__.__dict__["firewall_domain_name"] = firewall_domain_name
        __props__.__dict__["route_domain_name"] = route_domain_name
        __props__.__dict__["tgw_name"] = tgw_name
        return AviatrixAwsTgwIntraDomainInspection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="firewallDomainName")
    def firewall_domain_name(self) -> pulumi.Output[str]:
        """
        Firewall domain name.
        """
        return pulumi.get(self, "firewall_domain_name")

    @property
    @pulumi.getter(name="routeDomainName")
    def route_domain_name(self) -> pulumi.Output[str]:
        """
        Route domain name.
        """
        return pulumi.get(self, "route_domain_name")

    @property
    @pulumi.getter(name="tgwName")
    def tgw_name(self) -> pulumi.Output[str]:
        """
        AWS TGW name.
        """
        return pulumi.get(self, "tgw_name")

